export default {
  layout: {
    items: {
      size: 128, // imgsize
      gutter: 8 // padding
    },
    min_margin: 16,
    min_rows: 2,
    min_cols: 3
  },
  misc: {
    scrollrows: 4
  },
  api: {
    uri: "//f0ck.me/api/",
    modes: [
      "user",
      "mime",
      "new"
    ]
  },
  tpl: {
    row: ({ rowid, items }) => `<div class="row" data-row="${rowid}">${items}</div>`,
    item: ({ id, }) => `<a href="//f0ck.me/${id}" class="thumb" style="background-image:url('//f0ck.me/t/${id}.png')"></a>`
  },
  container: {
    debug: document.querySelector("div.navbar"),
    page: document.querySelector("div#page"),
    thumbs: document.querySelector("div#thumbs")
  }
};